# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

from customtest import *


class TestGeolibIntersections(CustomTest):

    def test_Intersection_droites(self):
        d1 = rand_dte()
        d2 = rand_dte()
        A = ALL.Intersection_droites(d1, d2)
        if not d1.parallele(d2):
            self.assert_(A in d1 and A in d2)
        d3 = ALL.Parallele(d1, rand_pt())
        self.assert_(not ALL.Intersection_droites(d1, d3).existe)

    def test_Intersection_droite_cercle(self):
        A = ALL.Point(-3.075, 2.0, legende=2)
        B = ALL.Point(0.0, 1.625, legende=2)
        c1 = ALL.Cercle_rayon(A, B)
        C = ALL.Point(-0.375, 4.425, legende=2)
        D = ALL.Point(3.25, 0.125, legende=2)
        d1 = ALL.Droite(C, D)
        self.assert_(not ALL.Intersection_droite_cercle(d1, c1).existe)
        C(-5.675, 4.95)
        I = ALL.Intersection_droite_cercle(d1, c1, True)
        self.assert_(I == (-4.87791007862, 4.51908023858))
        J = ALL.Intersection_droite_cercle(d1, c1, False)
        self.assert_(J == (0.0201000262814, 1.87113640036))
        
        

    def test_Intersection_cercles(self):
        A = ALL.Point(-4.4375, 1.95833333333, legende=2)
        B = ALL.Point(-2.10416666667, 0.875, legende=2)
        c1 = ALL.Cercle_rayon(A, B)
        C = ALL.Point(2.1875, 1.35416666667, legende=2)
        c2 = ALL.Cercle_rayon(C,B)
        D = ALL.Intersection_cercles(c2, c1, False, legende=2)
        self.assert_(D == (-1.9466976004889973, 2.6017297602107377))
        self.assert_(ALL.Intersection_cercles(c2, c1, True, legende=2) == B)
        self.assert_(ALL.Droite(A, C) == ALL.Mediatrice(B, D))



        
if __name__ == '__main__':
    unittest.main()
