# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

from customtest import *


class TestGeolibPolygones(CustomTest):

##    def test_Cote(self):
##        pass #  CRIRE
##
##    def test_Sommet(self):
##        pass #  CRIRE

    def test_Polygone(self):
        # cas gnral : polygone  11 cts :
        A = rand_pt()
        B = rand_pt()
        C = rand_pt()
        D = rand_pt()
        E = rand_pt()
        F = rand_pt()
        G = rand_pt()
        H = rand_pt()
        I = rand_pt()
        J = rand_pt()
        K = rand_pt()
        p = ALL.Polygone(A, B, C, D, E, F, G, H, I, J, K)
        self.assert_(isinstance(p.etiquette, ALL.Label_polygone))
        self.assert_(p.sommets[0] == A and p.sommets[10] == K)
        self.assert_(ALL.Milieu(B, C) in p.cotes[1])
        self.assertAlmostEqual(p.centre.coordonnees, ALL.Barycentre(A, B, C, D, E, F, G, H, I, J, K).coordonnees)
        # cas particuliers :
        t = ALL.Polygone(A, B, C)
        O = t.centre_cercle_circonscrit
        self.assertAlmostEqual(ALL.Segment(O, A).longueur, ALL.Segment(O, C).longueur)
        self.assert_(ALL.Droite(t.orthocentre, C).perpendiculaire(ALL.Droite(A, B)))
        self.assert_(t.__class__ is ALL.Triangle)
        p = ALL.Polygone(A, B, C,  D)
        self.assert_(p.__class__ is ALL.Quadrilatere)
        p = ALL.Polygone(A, B, C,  D, E)
        self.assert_(p.__class__ is ALL.Pentagone)
        p = ALL.Polygone(A, B, C,  D, E, F)
        self.assert_(p.__class__ is ALL.Hexagone)
        p = ALL.Polygone(A, B, C,  D, E, F, G)
        self.assert_(p.__class__ is ALL.Heptagone)
        p = ALL.Polygone(A, B, C,  D, E, F, G, H)
        self.assert_(p.__class__ is ALL.Octogone)
        self.assert_(p._hierarchie < p.sommets[0]._hierarchie < p.sommets[1]._hierarchie < p.sommets[7]._hierarchie < p._hierarchie + 1)
        

    def test_Triangle(self):
        A = rand_pt()
        B = rand_pt()
        C = rand_pt()
        t = ALL.Triangle(A, B, C)
        O = t.centre_cercle_circonscrit
        self.assertAlmostEqual(ALL.Segment(O, A).longueur, ALL.Segment(O, C).longueur)

    def test_Quadrilatere(self):
        A = rand_pt()
        B = rand_pt()
        C = rand_pt()
        D = rand_pt()
        p = ALL.Quadrilatere(A, B, C, D)
        self.assertAlmostEqual(p.centre.coordonnees, ALL.Barycentre(A, B, C, D).coordonnees)

    def test_Pentagone(self):
        A = rand_pt()
        B = rand_pt()
        C = rand_pt()
        D = rand_pt()
        E = rand_pt()
        p = ALL.Pentagone(A, B, C, D, E)
        self.assertAlmostEqual(p.centre.coordonnees, ALL.Barycentre(A, B, C, D, E).coordonnees)

    def test_Hexagone(self):
        A = rand_pt()
        B = rand_pt()
        C = rand_pt()
        D = rand_pt()
        E = rand_pt()
        F = rand_pt()
        p = ALL.Hexagone(A, B, C, D, E, F)
        self.assertAlmostEqual(p.centre.coordonnees, ALL.Barycentre(A, B, C, D, E, F).coordonnees)

    def test_Heptagone(self):
        A = rand_pt()
        B = rand_pt()
        C = rand_pt()
        D = rand_pt()
        E = rand_pt()
        F = rand_pt()
        G = rand_pt()
        p = ALL.Heptagone(A, B, C, D, E, F, G)
        self.assertAlmostEqual(p.centre.coordonnees, ALL.Barycentre(A, B, C, D, E, F, G).coordonnees)

    def test_Octogone(self):
        A = rand_pt()
        B = rand_pt()
        C = rand_pt()
        D = rand_pt()
        E = rand_pt()
        F = rand_pt()
        G = rand_pt()
        H = rand_pt()
        p = ALL.Octogone(A, B, C, D, E, F, G, H)
        self.assertAlmostEqual(p.centre.coordonnees, ALL.Barycentre(A, B, C, D, E, F, G, H).coordonnees)

    def test_Parallelogramme(self):
        A = rand_pt()
        B = rand_pt()
        C = rand_pt()
        p = ALL.Parallelogramme(A, B, C)
        D = p.sommets[3]
        self.assertEqual(ALL.Vecteur(A, B), ALL.Vecteur(D, C))

    def test_Rectangle(self):
        pass #  CRIRE

    def test_Losange(self):
        pass #  CRIRE

    def test_Polygone_regulier_centre(self):
        O = rand_pt()
        M = rand_pt()
        p = ALL.Polygone_regulier_centre(O, M, 15)
        self.assert_(len(p.cotes) == 15)
        self.assert_(p.centre is O)
        for Mi in p.sommets:
            self.assertAlmostEqual(ALL.Segment(O, Mi).longueur, ALL.Segment(O, M).longueur)
        for i in xrange(10):
            coeffs = tuple(random() for i in xrange(15))
            G = ALL.Barycentre(*zip(p.sommets, coeffs))
            self.assert_(G in p)
            G.points_ponderes[randint(11)].coefficient = -5
            self.assert_(G not in p)
        # cas particuliers :
        p = ALL.Polygone_regulier_centre(O, M, 3)
        self.assert_(isinstance(p,  ALL.Triangle))
        p = ALL.Polygone_regulier_centre(O, M, 4)
        self.assert_(isinstance(p,  ALL.Quadrilatere))

    def test_Triangle_equilateral_centre(self):
        O = rand_pt()
        M = rand_pt()
        p = ALL.Triangle_equilateral_centre(O, M)
        self.assert_(p.centre.existe and p.centre is O)
        self.assert_(p.centre_cercle_circonscrit.existe)
        self.assert_(p.centre_cercle_inscrit.existe)
        self.assert_(p.orthocentre.existe)
        self.assert_(p.orthocentre == p.centre == p.centre_cercle_circonscrit == p.centre_cercle_inscrit)

    def test_Carre_centre(self):
        O = rand_pt()
        M = rand_pt()
        p = ALL.Carre_centre(O, M)
        self.assert_(p.centre.existe and p.centre is O)
        self.assert_(len(p.cotes) == 4)
        self.assertAlmostEqual(p.aire,  p.cotes[0].longueur**2)

    def test_Polygone_regulier(self):
        O = rand_pt()
        M = rand_pt()
        p = ALL.Polygone_regulier(O, M, 15)
        self.assert_(len(p.cotes) == 15)
        self.assert_(p.centre in ALL.Mediatrice(O, M))
        for i in xrange(15):
            self.assertAlmostEqual(ALL.Segment(p.sommets[i%15], p.sommets[(i+1)%15]).longueur, ALL.Segment(p.sommets[(i+2)%15], p.sommets[(i+3)%15]).longueur)
        p = ALL.Polygone_regulier(O, M, 3)
        self.assert_(isinstance(p,  ALL.Triangle))
        p = ALL.Polygone_regulier(O, M, 4)
        self.assert_(isinstance(p,  ALL.Quadrilatere))

    def test_Triangle_equilateral(self):
        O = rand_pt()
        M = rand_pt()
        p = ALL.Triangle_equilateral(O, M)
        self.assert_(p.centre.existe)
        self.assert_(p.centre_cercle_circonscrit.existe)
        self.assert_(p.centre_cercle_inscrit.existe)
        self.assert_(p.orthocentre.existe)
        self.assert_(p.orthocentre == p.centre == p.centre_cercle_circonscrit == p.centre_cercle_inscrit)

    def test_Carre(self):
        O = rand_pt()
        M = rand_pt()
        p = ALL.Carre(O, M)
        A, B, C, D = p.sommets
        self.assert_(p.centre == ALL.Milieu(A, C) == ALL.Milieu(B, D))
        self.assert_(A == O and B == M)
        self.assert_(len(p.cotes) == 4)
        self.assertAlmostEqual(p.aire,  p.cotes[0].longueur**2)
        
        
if __name__ == '__main__':
    unittest.main()
